#import <CoreFoundation/CoreFoundation.h>
//#import <ApplicationServices/ApplicationServices.h>
#import <CoreGraphics/CGContext.h>
#import <UIKit/UIKit.h>
#import <UIKit/UITextView.h>
#import <UIKit/UIFont.h>
//#import <NSGraphicsContext.h>
#import <math.h>
#import "boussole.h"

static inline CGFloat radians (CGFloat degrees) {return degrees * M_PI/180.;}

@implementation boussole

@synthesize angle;

- (id)init {
	self = [super init];
	self.angle = 90.;
	return self;
}

- (id)initWithFrame:(CGRect )frame {
	self = [super initWithFrame: frame];
	self.angle = 90.;
	return self;
}
/*-(id)initWithFrameAndImage:(CGRect) frame image:(UIImage *) image {
	self = [super initWithFrame: frame];
	[self.image retain:image];
	return self;
}*/

-(void)drawRect:(CGRect)rect
{
	CGRect imgRect = [self bounds];
	UIImage *myImage = [UIImage 
		imageNamed :@"rose_des_vents.png"];
	CGImageRef imageRef = myImage.CGImage;
	CGContextRef myContext = UIGraphicsGetCurrentContext();

	CGFloat x=imgRect.size.width/2;
	CGFloat y=imgRect.size.height/2;
	CGFloat angl = radians(self.angle);
	CGFloat tx = x-(x*cosf(angl)+y*sinf(angl));
    CGFloat ty = y+(x*sinf(angl)-y*cosf(angl));



	CGContextTranslateCTM (myContext, tx, ty);
	CGContextRotateCTM(myContext, - angl);
	CGContextDrawImage(myContext, imgRect, imageRef);
}
/*- (void) setAngle:(CGFloat) angle {
	self.angle = angle;
	[self setNeedsDisplay]; 
}*/
	
- (void) refresh {
	[self setNeedsDisplay]; 
}
@end

