#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <pthread.h>
#include <unistd.h>

#include <btstack/btstack.h>
#import <CoreFoundation/CoreFoundation.h>
#import <UIKit/UIKit.h>
#import <UIKit/UITextView.h>
#import <UIKit/UIFont.h>
#import "testGPS.h"
#import "boussole.h"
#import "bluetooth.h"

#undef GPS
int internal,noinit;
char contentTrame[256];
UITextField *txtHeure;
UITextField *txtLat;
UITextField *txtLong;
UITextField *txtPos;
boussole *bsl;
bluetooth *bluetoothThread;
NSTimer *timer;
CGFloat angle;

bd_addr_t addr = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00}; 
char PIN[] = "0000";

int DEBUG = 0;

#define TEMP_POS 7
#define TEMP_SIZE 10
#define LAT_POS 18 
#define LAT_SIZE 9
#define LONG_POS 30
#define LONG_SIZE 10
#define SPEED_POS 51
#define SPEED_SIZE 6
void afficheHeure(char *trame) {
	char temp[10];
	char speed[10];
	char lattitude[11];
	char longitude[15];

	if (strstr(trame,"$GPGGA") != NULL) {
		memcpy(temp, &trame[TEMP_POS],TEMP_SIZE);
		temp[TEMP_SIZE-1]='\0';
		memcpy(lattitude, &trame[LAT_POS],LAT_SIZE);
		lattitude[LAT_SIZE]=trame[LAT_POS+LAT_SIZE+1];
		lattitude[LAT_SIZE+1]='\0';

		memcpy(longitude, &trame[LONG_POS],LONG_SIZE);
		longitude[LONG_SIZE]=trame[LONG_POS+LONG_SIZE+1];
		longitude[LONG_SIZE+1]='\0';

		[[NSString alloc] initWithCString : temp encoding : 1];

		[txtHeure performSelectorOnMainThread:@selector(setText:) 
			withObject: [[NSString alloc] initWithCString : temp encoding : 1]
			waitUntilDone:YES];
		[txtLat performSelectorOnMainThread:@selector(setText:) 
			withObject: [[NSString alloc] initWithCString : lattitude encoding : 1]
			waitUntilDone:YES];
		[txtLong performSelectorOnMainThread:@selector(setText:) 
			withObject: [[NSString alloc] initWithCString : longitude encoding : 1]
			waitUntilDone:YES];
	} else if (strstr(trame, "$GPRMC") != NULL) {
		// Test sur 36 bits pour faire la verif de la validite
		memcpy(speed, &trame[SPEED_POS],SPEED_SIZE);
		speed[SPEED_SIZE]='\0';
		CGFloat speedf = strtof(speed,NULL);
		bsl.angle = speedf;
		[bsl setAngle: speedf];
		//[bsl performSelectorOnMainThread:@selector(refresh:)
		//	withObject: nil waitUntilDone:YES];
		[txtPos performSelectorOnMainThread:@selector(setText:) 
			withObject: [[NSString alloc] initWithCString : speed encoding : 1]
			waitUntilDone:YES];

	}
	//[bsl refresh];
}

int main (int argc, char **argv){
	uint8_t tmp[256];
//#ifdef GPS
//	sprintf(tmp,"00:0D:B5:65:71:B2");
//#else
	sprintf(tmp,"00:0B:CE:03:35:14");
//#endif
	sscan_bd_addr(tmp ,addr);
	snprintf(PIN, 5, "%01d%01d%01d%01d", 0, 0, 0, 0);
	
	NSAutoreleasePool *autoreleasePool = [[ NSAutoreleasePool alloc ] init ];

	int returnCode = UIApplicationMain(argc, argv, @"testGPS", @"testGPS");
	[ autoreleasePool release ];
	//bt_close();
	return returnCode;
}
@implementation testGPS
- (void) receiptTrames:(char *) content taille:(int)size {
	char *c;
	content[size]='\0';
	do {
		c = strchr(content,'\r');
		if (c == NULL) {
			strcat(contentTrame,content);
			return;
		}
		*c = '\0';
		c+=2;
		if (strlen(content) == 0)
		continue;
		strcat(contentTrame,content);
		afficheHeure(contentTrame);
		memset(contentTrame,'\0',256);
		content = c;
	} while (strlen(content) > 0);
}

- (void)timerFireMethod:(NSTimer*)theTimer {
	[bsl refresh];
}

- (void)applicationDidFinishLaunching: (UIApplication *) application {
	bluetoothThread = [[bluetooth alloc ]init:addr pin:PIN];	
	bluetoothThread.delegate = self;
	window = [[[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]] autorelease];

	CGRect windowRect = [ [ UIScreen mainScreen ] applicationFrame ];
	windowRect.origin.x = windowRect.origin.y = 0.0f;

	// Create the window object and assign it to the
	// window instance variable of the application delegate.

	window = [[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
	window.backgroundColor = [UIColor whiteColor];
	
	/* heure */
	CGRect txtFrame1 = CGRectMake(50,50,150,150);
	txtHeure = [[UITextField alloc] initWithFrame:txtFrame1];
	txtHeure.text = @"testGPS";
	/* lattitude */
	CGRect txtFrame2 = CGRectMake(50,70,150,150);
	txtLat = [[UITextField alloc] initWithFrame:txtFrame2];
	txtLat.text = @"testGPS";
	/* longitude */
	CGRect txtFrame3 = CGRectMake(50,90,150,150);
	txtLong = [[UITextField alloc] initWithFrame:txtFrame3];
	txtLong.text = @"testGPS";
	CGRect txtFrame4 = CGRectMake(50,110,150,150);
	txtPos = [[UITextField alloc] initWithFrame:txtFrame4];
	txtPos.text = @"testGPS";
	
	UIFont *font = [UIFont boldSystemFontOfSize:18.0];
	txtHeure.font = font;
	txtLat.font = font;
	txtLong.font = font;
	txtPos.font = font;

    CGRect imgRect2 = CGRectMake(50,250,200,200);
    bsl = [[boussole alloc]
	initWithFrame: imgRect2];
	bsl.angle = 30.;


	[ window  addSubview: txtHeure ];
	[ window  addSubview: txtLat ];
	[ window  addSubview: txtLong ];
	[ window  addSubview: txtPos ];
	[ window  addSubview: bsl ];
	//[txtView release];

   timer = [NSTimer scheduledTimerWithTimeInterval:1
	      	target:self selector:@selector(timerFireMethod:)
			userInfo:nil repeats:YES];
	// Show the window.
	[window makeKeyAndVisible];
	[bluetoothThread run];
}

@end

